--libs
bump = require "libs.bump"
sti = require "libs.sti"
bump_debug = require"libs.bump_debug"
require "libs.camera"
function love.load()
	lg = love.graphics
	world = bump.newWorld()
	map = sti("maps/Map[0].lua", {"bump"})
	map:bump_init(world)
	Player = {
	sprite = lg.newImage("textures/mn_spt_3.png"),
	x = 80,
	y = 320,
	w = 80,
	h = 160,
	xvel = 0,
	maxVel = 76,
	speed = 76,
	dir = 1,
	moving = false
	}
	gui_buttons = lg.newImage("textures/Button.png")
	Psprite = lg.newSpriteBatch(Player.sprite, 1)
	gui_button = lg.newSpriteBatch(gui_buttons,2)
	SetupPsprite()
	world:add(Player,Player.x,Player.y,Player.w,Player.h)
	SetupGui()
end
function SetupGui()
	LeftT = lg.newQuad(0,0,64,64,128,128)
	RightT = lg.newQuad(64,0,64,64,128,128)
	Left = lg.newQuad(0,64,64,64,128,128)
	Right = lg.newQuad(64,64,64,64,128,128)
	gui_button:add(Left,90,595,0,2)
	gui_button:add(Right,1040,595,0,2)
end
function SetupPsprite()
	IdleR = {}
	IdleL = {}
	WalkR = {}
	WalkL = {}
	frameWidth = 80
	frameHeight = 160
	width = 1280 
	height = 640
	frames = IdleR
	for frame = 1,16 do
    	IdleR[frame] = love.graphics.newQuad((frame-1) * frameWidth, 0, frameWidth, frameHeight, width, height)
  	end
  	for frame = 1,16 do
    	IdleL[frame] = love.graphics.newQuad((frame-1) * frameWidth, 160, frameWidth, frameHeight, width, height)
  	end
  	for frame = 1,8 do
    	WalkL[frame] = love.graphics.newQuad((frame-1) * frameWidth, 320, frameWidth, frameHeight, width, height)
  	end
  	for frame = 1,8 do
    	WalkR[frame] = love.graphics.newQuad((frame-1) * frameWidth, 480, frameWidth, frameHeight, width, height)
  	end
  	CF = 1
  	Psprite:clear()
  	Psprite:add(frames[CF],Player.x,Player.y)
end
local ETime = 0
function UpdatePsprite(dt)
	if ETime > 0.1 then
		Psprite:clear()
    	CF = CF + 1
      	if CF > #frames then
        	CF = 1
      	end
  		Psprite:add(frames[CF],Player.x,Player.y)
  		ETime = 0
 	 end
 	 Psprite:flush()
end
function love.update(dt)
	ETime = ETime + dt
	UpdatePsprite()
	map:update(dt)
	if love.keyboard.isDown("d") then 
		Player.dir = 1
		Player.moving = true
		elseif love.keyboard.isDown("a") then
			Player.dir = -1
			Player.moving = true
				if Player.dir == 1 then 
					Player.vel = 0
				end
	else
		Player.moving = false
	end
	if Player.moving == true then
		if Player.dir == 1 then 
			frames = WalkR
				Player.xvel = Player.xvel + Player.speed
			elseif Player.dir == -1 then 
				frames = WalkL
				Player.xvel = Player.xvel + Player.speed
		end
		elseif Player.moving == false then 
			if Player.dir == 1 then 
				frames = IdleR
				elseif Player.dir == -1 then 
					frames = IdleL
			end
	end
	Player.xvel = Player.xvel - 50
	if Player.xvel > Player.maxVel then 
		Player.xvel = Player.maxVel
	end
	if Player.xvel < 0 then
		Player.xvel = 0
	end
	tx  = math.floor(Player.x - 1280/16)
	Player.x = Player.x + Player.dir*Player.xvel*dt
	Player.x, Player.y, cols = world:move(Player, Player.x,Player.y)
end
function love.draw()
	lg.draw(gui_button)
	map:draw(-tx)
	lg.draw(Psprite)
	lg.rectangle("line",Player.x,Player.y,Player.w,Player.h)
	love.graphics.print("Current FPS: "..tostring(love.timer.getFPS( )), 10, 10)
	lg.print("Frames: "..CF,10,20)
	map:bump_draw(world)
	--world:update()
	--bump_debug.draw(world)
	
end
function love.touchpressed(id,x,y)
end
function love.touchreleased(id,x,y)
end